Bug 1118802 - [query action] --last should be first class switch/modifier (e.g., reasonable output of --last + --queryformat combo)
Summary: [query action] --last should be first class switch/modifier (e.g., reasonable...
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: rpm
Version: 20
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Packaging Maintenance Team
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-07-11 14:39 UTC by Jan Pokorný [poki]
Modified: 2015-06-29 21:33 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-06-29 21:33:24 UTC


Attachments (Terms of Use)

Description Jan Pokorný [poki] 2014-07-11 14:39:54 UTC
When both options specified, the user formatted output is sorted
as expected, but it is preceded with output as if standalone --last
was specified, which is rather counter-productive (think a script
wants both custom formatting and the install-time descending order).

AFAIK not specifying --last does not guarantee any order, at least
not promised in the man page, not sure if it should do so.

In other words, --last and --queryformat should be "combinative"
(cooperate on the common product), not "solo players" as is the case
now:

$ rpm -q --queryformat="%{V}-%{R}\n" -- kernel
> 3.14.5-200.fc20
> 3.14.8-200.fc20
> 3.14.9-200.fc20

$ rpm -q --last -- kernel
> kernel-3.14.9-200.fc20.x86_64                 Thu 03 Jul 2014 04:09:19 PM CEST
> kernel-3.14.8-200.fc20.x86_64                 Tue 24 Jun 2014 01:35:01 PM CEST
> kernel-3.14.5-200.fc20.x86_64                 Mon 09 Jun 2014 03:30:55 PM CEST

happens, not expected:

$ rpm -q --last --queryformat="%{V}-%{R}\n" -- kernel
> kernel-3.14.9-200.fc20.x86_64                 Thu 03 Jul 2014 04:09:19 PM CEST
> kernel-3.14.8-200.fc20.x86_64                 Tue 24 Jun 2014 01:35:01 PM CEST
> kernel-3.14.5-200.fc20.x86_64                 Mon 09 Jun 2014 03:30:55 PM CEST
> 3.14.9-200.fc20...............................
> 3.14.8-200.fc20...............................
> 3.14.5-200.fc20...............................

[note: the trailing dots are just to emphasize un{needed,wanted} trailing
spaces being produced (!)]

should happen:
$ rpm -q --last --queryformat="%{V}-%{R}\n" -- kernel
> 3.14.9-200.fc20
> 3.14.8-200.fc20
> 3.14.5-200.fc20


Tested with:
rpm-4.11.2-2.fc20.x86_64
rpm-4.8.0-37.el6.x86_64

Comment 1 Panu Matilainen 2014-07-14 08:20:33 UTC
This is "expected", --last is implemented as a funky popt alias which is a queryformat of its own, and each specified queryformat produces separate output, they dont "stack":

rpm     alias --last --qf '%|INSTALLTIME?{%{INSTALLTIME}}:{000000000}| %{NVRA} %|INSTALLTIME?{%{INSTALLTIME:date}}:{(not installed)}|\n' \
        --pipe "sort -r -n | sed 's,^[0-9]\+ ,,' | awk '{printf(\"%-45s %-s\n\", $1, substr($0,length($1)+2))}' " \
        --POPTdesc=$"list package(s) by install time, most recent first"

This isn't fixable as things are, rpm would need to sort internally for that. Which seems like a fairly reasonable thing... so we could turn this into an RFE for query output sorting.

Comment 2 Jan Pokorný [poki] 2014-07-14 14:24:01 UTC
Understood, let's consider it as a future feature, then.

Comment 3 Fedora End Of Life 2015-05-29 12:20:53 UTC
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 4 Fedora End Of Life 2015-06-29 21:33:24 UTC
Fedora 20 changed to end-of-life (EOL) status on 2015-06-23. Fedora 20 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.